#pragma once

#include "Stdafx.h"
#include <wininet.h>


class CWininet;

struct SContext
{
	CWininet* pObj;
	DWORD dwContext;
};


class CWininet
{

protected:

	SContext m_context;

	HANDLE m_hConnectedEvent;
	HANDLE m_hRequestOpenedEvent;
	HANDLE m_hRequestCompleteEvent;

	HINTERNET m_hInstance;
	HINTERNET m_hConnect;
	HINTERNET m_hRequest;


public:

	CWininet(void);
	~CWininet(void);


public:

	enum
	{
		CONTEXT_CONNECT,
		CONTEXT_REQUESTHANDLE
	};

	BOOL Connect(LPCTSTR lpszAddr,
			USHORT uPort = INTERNET_DEFAULT_HTTP_PORT,
			LPCTSTR lpszAgent = _T("AsyncClient"),
			DWORD dwTimeOut = 20000);

	BOOL SendRequest(LPCTSTR szURI, LPCTSTR lpszReferrer, DWORD dwTimeOut = 20000);
	DWORD Read(PBYTE pBuffer, DWORD dwSize, DWORD dwTimeOut = 20000);
	void Close();


	static void WINAPI Callback(HINTERNET hInternet,
				  DWORD dwContext,
				  DWORD dwInternetStatus,
				  LPVOID lpStatusInfo,
				  DWORD dwStatusInfoLen);

};
